package com.izouma.awesomeadmin.web;

import java.util.*;

import com.izouma.awesomeadmin.util.ExportExcelUtil;
import org.apache.commons.lang.StringUtils;
import org.apache.shiro.authz.annotation.RequiresAuthentication;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;
import com.izouma.awesomeadmin.constant.AppConstant;
import com.izouma.awesomeadmin.dto.Page;
import com.izouma.awesomeadmin.dto.Result;
import com.izouma.awesomeadmin.model.UserFileInfo;
import com.izouma.awesomeadmin.service.UserFileInfoService;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
*  controller类
*/
@Controller
@RequestMapping("/userFileInfo")
public class UserFileInfoController {

    @Autowired
    private UserFileInfoService userFileInfoService;

    /**
    * <p>获取全部记录。</p>
    */
    @RequiresAuthentication
    @RequestMapping(value = "/all", method = RequestMethod.GET)
    @ResponseBody
    public Result all(UserFileInfo record) {
        List<UserFileInfo> pp = userFileInfoService.getUserFileInfoList(record);
        return new Result(true, pp);
    }

    /**
    * <p>根据Id。</p>
    */
    @RequestMapping(value = "/getUserFileInfo", method = RequestMethod.GET)
    @ResponseBody
    public Result getUserFileInfo(@RequestParam(required = false, value = "id") String id) {
        UserFileInfo data = userFileInfoService.getUserFileInfoById(id);
        return new Result(true, data);
    }

    /**
    * <p>根据条件获取。</p>
    */
    @RequestMapping(value = "/getOne", method = RequestMethod.GET)
    @ResponseBody
    public Result getOne(UserFileInfo record) {
        UserFileInfo data = userFileInfoService.getUserFileInfo(record);
        return new Result(true, data);
    }


    /**
    * <p>分页查询。</p>
    */
    @RequestMapping(value = "/page", method = RequestMethod.GET)
    @ResponseBody
    public Result page(Page page, UserFileInfo record) {
        Map<String, Object> result = new HashMap<>();

        List<UserFileInfo> pp =userFileInfoService.getUserFileInfoByPage(page, record);

        result.put(AppConstant.PAGE, page);
        result.put("pp", pp);
        return new Result(true, result);
    }


    /**
    * <p>保存。</p>
    */
    @RequestMapping(value = "/save", method = RequestMethod.POST)
    @ResponseBody
    public Result save(UserFileInfo record) {
        boolean num = userFileInfoService.createUserFileInfo(record);
        if (num) {
        return new Result(true, record.getId());
        }
        return new Result(false, "保存异常");
    }

    /**
    * <p>更新信息。</p>
    */
    @RequestMapping(value = "/update", method = RequestMethod.POST)
    @ResponseBody
    public Result updateUserFileInfo(UserFileInfo record) {
        boolean num = userFileInfoService.updateUserFileInfo(record);
        if (num) {
        return new Result(true, "保存成功");
        }
        return new Result(false, "保存异常");
    }

    /**
    * <p>删除。</p>
    */
    @RequestMapping(value = "/del", method = RequestMethod.POST)
    @ResponseBody
    public Result deleteUserFileInfo(UserFileInfo record) {

        boolean num = userFileInfoService.deleteUserFileInfo(record);
        if (num) {
        return new Result(true, "删除成功");
        }
        return new Result(false, "删除异常");
    }

    /**
    * 导出Excel
    * @param request
    * @param response
    * @param record
    * @throws Exception
    */
    @RequestMapping(value = "/exportExcel", method = RequestMethod.GET)
    @ResponseBody
    public void exportExcel(HttpServletRequest request, HttpServletResponse response, UserFileInfo record) throws Exception {

    List<UserFileInfo> userFileInfos = userFileInfoService.getUserFileInfoList(record);


        String sheetName = "user_file_info";
        String titleName = "文件管理数据表";
        String fileName = "文件管理表";
        int columnNumber = 13;
        int[] columnWidth = { 20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20 };
        String[] columnName = {  "ID" ,   "删除标识" ,   "更新时间" ,   "更新人" ,   "创建时间" ,   "创建人" ,   "权限" ,   "用户" ,   "类型" ,   "文件名" ,   "URL" ,   "大小" ,   "备注"  };
        String[][] dataList = new String[userFileInfos.size()][13];

        for (int i = 0; i < userFileInfos.size(); i++) {

                        dataList[i][0] = String.valueOf(userFileInfos.get(i).getId());
                        dataList[i][1] = String.valueOf(userFileInfos.get(i).getDelFlag());
                        dataList[i][2] = String.valueOf(userFileInfos.get(i).getUpdateTime());
                        dataList[i][3] = String.valueOf(userFileInfos.get(i).getUpdateUser());
                        dataList[i][4] = String.valueOf(userFileInfos.get(i).getCreateTime());
                        dataList[i][5] = String.valueOf(userFileInfos.get(i).getCreateUser());
                        dataList[i][6] = String.valueOf(userFileInfos.get(i).getPower());
                        dataList[i][7] = String.valueOf(userFileInfos.get(i).getUserId());
                        dataList[i][8] = String.valueOf(userFileInfos.get(i).getTypeFlag());
                        dataList[i][9] = String.valueOf(userFileInfos.get(i).getFileName());
                        dataList[i][10] = String.valueOf(userFileInfos.get(i).getUrl());
                        dataList[i][11] = String.valueOf(userFileInfos.get(i).getFileSize());
                        dataList[i][12] = String.valueOf(userFileInfos.get(i).getRemark());
                    }


        ExportExcelUtil.ExportWithResponse(sheetName, titleName, fileName,
        columnNumber, columnWidth, columnName, dataList, response);


        }
    }

